$(document).ready(function () {
    $("body").off('click').on("click", '.remove', remove);
    $("body").on("focus blur change", '.item', getMsp);
    $("body").on("dblclick", '.rate', showMsp);
    $("body").on("blur focus keyup", '.qty, .rate, .amount, .discperc,.discount, .total', detailCal);
    $("body").on("blur focus keyup", '.subtotal, .litemdisc, .cdiscperc, .cdiscamt, .coukg, .courate, .couamt, netamt, .ladvance, .lesother, .balance, .dcperc, .dcbperc, .dcamt', mainCal);
    $("body").on("focus change", '.srno_0, .prodtype', validProdType);
    $("body").on("change", '.prodtype', generatePrint);
    $("body").on("blur", '.rate, .discperc', validMsp);
    $("body").on("blur", '.rate', validMrp);
    $("body").on("change", '.prodtype', prodSelect);
    $("body").on("blur change", '.barcode', GetItemFromCode);
//    $("body").on("blur", '.amount', autoAddRows);
    $("body").on("focus blur", '.amount', storOtpSucs);
    $("body").on("blur", '.qty', noZeroAcptQty);
    $("body").on("blur", '.rate', noZeroAcptRate);
    $("body").on("blur", '.cdiscperc, .lesother ', checkMspTotal);

    function noZeroAcptQty() {
        var $row = $(this).closest("tr"),
                mqty = $row.find(".qty").val();
        if (mqty > 0) {
        } else {
            alert('Qty Cannot be Zero');
            $row.find(".item").focus();
        }
    }
    function noZeroAcptRate() {
        var $row = $(this).closest("tr"),
                mrate = $row.find(".rate").val();

        if (mrate > 0) {
        } else {
            alert('Rate Cannot be Zero');
            $row.find(".mrp").focus();
        }
    }

    function storOtpSucs() {
        var $row = $(this).closest("tr"),
                mrate = $row.find(".rate").val(),
                motp = $(".otprecv").val(),
                mmsp = $row.find(".msp").val();
        if (motp != '') {
            if (mrate < mmsp) {
                $(".otprowsucs").val("1");
            } else {
                $(".otprowsucs").val("");
            }
        }
    }

//    var lesother = $(".lesother").val(),
//            cdiscperc = $(".cdiscperc").val();
//
//    if (cdiscperc <= 0) {
//        $(".cdiscperc").attr("readonly", true);
//    }
//    if (lesother <= 0) {
//        $(".lesother").attr("readonly", true);
//    }

    $(".gendsotp").click(function () {
        var party = $(".party").val(),
                subtotal = $(".subtotal").val(),
                vouchno = $(".vouchno").val(),
                data = {party: party, subtotal: subtotal, vouchno: vouchno};

        $.ajax({
            type: 'GET',
            dataType: 'json',
            url: "getGenDiscOtp.php",
            data: data,
            success: function (response) {

                $("#overlay_form").show();

                $(".normotp").hide();
                $(".lesdsotp").show();
                var m = response;
                $(".otpdssend").val(m.otpdssend);


//                $("#overlay_form").show();
//                var myEcho = "<h3>M.S.P = " + m.msp + "</h3>";
//                $(".genotp").hide();
//                $("#otp").val(m.msp);
                alert("OTP Send to Registered Mobile No.");
                $(".otpdssend").focus();
            }
        });
    });


//    function autoAddRows() {
//        if ($(this).closest("tr").is(":last-child")) {
//            AddRows();
//        }
////        var ctr = $('#items').val();
////        var tr = $(this).closest("tr");
////        var srno = tr.find(".srno").val();
////        if (srno == ctr) {
////            AddRows();
////        }
//    }

    $(".subdsotp").click(function () {
        var otpdsrecv = $(".otpdsrecv").val(),
                otpdssend = $(".otpdssend").val();
        if (otpdsrecv != '') {
            if (otpdsrecv == otpdssend) {
                $(".otpdssucs").val("1");
                $("#overlay_form").hide();
                $(".cdiscperc").removeAttr("readonly", true);
                $(".lesother").removeAttr("readonly", true);
                $(".cdiscperc").focus();
                $("#ssubmit").show();

            } else {
                alert("OTP Does Not Match");
                $(".otpdsrecv").val("");
                $(".otpdssucs").val("");
            }
        }
    });

    $(".subotp").click(function () {
        var otprecv = $(".otprecv").val(),
                otpsend = $(".otpsend").val();
        if (otprecv != '') {
            if (otprecv == otpsend) {
                $(".otpsucs").val("1");
                $("#overlay_form").hide();
                $("#ssubmit").show();
                $(".rate").focus();
            } else {
                alert("OTP Does Not Match");
                $(".otprecv").val("");
                $(".otpsucs").val("");
            }
        }
    });


///////////////////////////////////////////////////IMP - START//////////////////////////////////////////////////

    function GetItemFromCode() {
        var $row = $(this).closest("tr");
        var itemcode = $row.find(".barcode").val();
        var prodtype = $(".prodtype").val();
        $.post('show_item_dtl.php', {itemcode: itemcode, prodtype: prodtype}, function (data) {
            if (data != '') {
                $row.find(".item").html(data).trigger("change");
//                $row.find(".item").html(data).trigger("change");

            }
//            $row.find(".itemcode").val(itemcode);
        });
    }

    function prodSelect() {
        var prodtype = $(".prodtype").val(),
                data = {prodtype: prodtype};

        $.ajax({
            type: 'GET',
            dataType: 'html',
            url: "getTypeItem.php",
            data: data,
            success: function (response) {
                var m = response;
                $(".item").html(m);
            },
            error: function (request, textStatus, errorThrown) {

            }
        });

    }

    function validMsp() {
        $(".ratemspless").show();
        var tr = $(this).closest("tr"),
                otpsucs = $(".otpsucs").val(),
                otprowsucs = tr.find(".otprowsucs").val(),
                itemname = tr.find(".item").val(),
                rate = tr.find(".rate").val(),
                msp = tr.find(".msp").val(),
                qty = tr.find(".qty").val(),
                srno = tr.find(".srno").val(),
                total = tr.find(".total").val(),
                discperc = tr.find(".discperc").val(),
                mspamt = parseFloat(msp) * parseFloat(qty);
        if (otpsucs == "1" || otprowsucs == "1") {

        } else {
            if (rate > 0) {
                if (parseFloat(rate) < parseFloat(msp) && parseFloat(rate) != parseFloat(msp)) {
//                alert("Rate Cannot Be Less Than M.S.P");
                    $("#overlay_form").show();
                    $("#close_form1").hide();

                    $(".normotp").show();
                    $(".lesdsotp").hide();
//                var myEcho = "<h3>M.S.P = " + msp + "</h3>";
                    $(".genotp").show();
                    $("#browdata").val(msp);
                    $("#rowitm").val(itemname);
                    $("#rowsrno").val(srno);
                    $("#rowqty").val(qty);
                    $("#rowrate").val(rate);
//                    tr.find(".rate").val("0");
                    tr.find(".rate").attr("readonly", true);
                    $("#ssubmit").hide();
//                    tr.find(".rate").focus();

                }
                if (discperc > 0) {
                    if (parseFloat(total) < parseFloat(mspamt) && parseFloat(total) != parseFloat(mspamt)) {
                        alert("Total Cannot Be Less Than M.S.P-Total");
                        tr.find(".discperc").val("0");
                        tr.find(".discount").val("0");
                        tr.find(".discperc").focus();

                    }
                }
            }
        }
    }

    function validMrp() {
        var tr = $(this).closest("tr"),
                rate = tr.find(".rate").val(),
                mrp = tr.find(".mrp").val();
        if (rate > 0) {
            if (parseFloat(rate) > parseFloat(mrp)) {
                alert("Rate Cannot Be Greater Than M.R.P");
                tr.find(".rate").val("0");
            }
        }
    }

    if ($(".prodtype").val() == "") {
        $(".item").prop("disabled", true);
        $(".barcode").prop("disabled", true);
        $(".myPrint").attr("href", "");
    }

    function generatePrint() {
        var vouch = $(".vouchno").val();
        var prodtype = $(".prodtype").val();


        if (prodtype == "P") {
            $(".myPrint").attr("href", "salep_print.php?vouchno=" + vouch);
            $(".myPrint").attr("target", "_blank");
        } else {
            $(".myPrint").attr("href", "#");
            $(".myPrint").attr("target", "");
        }
    }
    generatePrint();

    $(document).keydown(function (e) {
        if (e.ctrlKey && (String.fromCharCode(e.which).toLowerCase() === 'm')) {
            rajEvent = new Event('CTR+M');
            document.dispatchEvent(rajEvent);
        }
    });

    $(document).keydown(function (e) {
        if (e.ctrlKey && (String.fromCharCode(e.which).toLowerCase() === 'b')) {
            rajEvent = new Event('CTR+B');
            document.dispatchEvent(rajEvent);
        }
    });

    document.addEventListener('CTR+M', showMsp, false);
    document.addEventListener('CTR+B', showPrint, false);

    function showPrint() {
        var vouchno = $(".vouchno").val();
        var prodtype = $(".prodtype").val();
        if (prodtype == "P") {
            window.open("salep_print.php?vouchno=" + vouchno, "_blank");
        }
    }

    $(".genotp").click(function () {
        var rowitem = $(".rowitm").val(),
                rowqty = $(".rowqty").val(),
                rowrate = $(".rowrate").val(),
                vouchno = $(".vouchno").val(),
                data = {rowitem: rowitem, rowqty: rowqty, rowrate: rowrate, vouchno: vouchno};

        $.ajax({
            type: 'GET',
            dataType: 'json',
            url: "getGenratedOtp.php",
            data: data,
            success: function (response) {
                var m = response;
                $(".otpsend").val(m.otpsend);


//                $("#overlay_form").show();
//                var myEcho = "<h3>M.S.P = " + m.msp + "</h3>";
//                $(".genotp").hide();
                $("#browdata").val(m.msp);
                alert("OTP Send to Registered Mobile No.");
                $(".otpsend").focus();
            }
        });
    });

    function getMsp() {
        var tr = $(this).closest("tr"),
                itemname = tr.find(".item").val(),
                data = {itemname: itemname};

        $.ajax({
            type: 'GET',
            dataType: 'json',
            url: "getItemMsp.php?m=a",
            data: data,
            success: function (response) {
                var m = response;
                tr.find(".barcode").val(itemname);
                tr.find(".mrp").val(m.mrp);
                if (tr.find(".rate").val() == 0) {
                    tr.find(".rate").val(m.rate);
                }
                tr.find(".msp").val(m.msp);
                tr.find(".unit").val(m.unit).trigger("change");
//                $("#overlay_form").show();
                var myEcho = "<h3>M.S.P = " + m.msp + "</h3>";
                $(".genotp").hide();
                $("#browdata").html(myEcho);
            }
        });
    }

    function showMsp() {
//        var tr = $(this).closest("tr"),
//                itemname = tr.find(".item").val(),
//                data = {itemname: itemname};
        $(".ratemspless").hide();
        var itemname = $(document.activeElement.closest("tr")).find('.item').val(),
                data = {itemname: itemname};


        $.ajax({
            type: 'GET',
            dataType: 'json',
            url: "getItemMsp.php?m=a",
            data: data,
            success: function (response) {
                var m = response;
                $("#overlay_form").show();
                var myEcho = "<h3>M.S.P = " + m.msp + "</h3>";
                $("#browdata").html(myEcho);
                $(".genotp").hide();
            }
        });
    }

    function validProdType() {
        var prodtype = $(".prodtype").val();

        if (prodtype == "") {
            $(".barcode").prop("disabled", true)
            $(".item").prop("disabled", true)
            $(".prodtype").select2("open");
            alert("Please Select The Product Type");
        } else {
            $(".barcode").prop("disabled", false);
            $(".item").prop("disabled", false);
        }
    }

///////////////////////////////////////////////////IMP - END//////////////////////////////////////////////////

///////////////////////////////////////////////////CALCULATION - START//////////////////////////////////////////////////

    function detailCal() {
        var tr = $(this).closest("tr"),
                qty = tr.find(".qty").val(),
                mrp = tr.find(".mrp").val(),
                msp = tr.find(".msp").val(),
                rate = tr.find(".rate").val(),
                amount = (parseFloat(qty) * parseFloat(rate)).toFixed(2),
                mspamount = (parseFloat(qty) * parseFloat(msp)).toFixed(2),
                discperc = tr.find(".discperc").val(),
                discount = (discperc * amount / 100).toFixed(2),
                total = (parseFloat(amount) - parseFloat(discount)).toFixed(2);

        tr.find(".amount").val(amount);
        tr.find(".mspamount").val(mspamount);
        tr.find(".discount").val(discount);
        tr.find(".total").val(total);


        var val = 0;
        $(".amount").each(function () {
            if (!isNaN(this.value) && this.value.length != 0) {
                val += parseFloat(this.value);
            }
        });
        $(".subtotal").val(val);

        var val2 = 0;
        $(".discount").each(function () {
            if (!isNaN(this.value) && this.value.length != 0) {
                val2 += parseFloat(this.value);
            }
        });
        $(".litemdisc").val(val2);

        var val3 = 0;
        $(".mspamount").each(function () {
            if (!isNaN(this.value) && this.value.length != 0) {
                val3 += parseFloat(this.value);
            }
        });
        $(".msptotal").val(val3);
        mainCal();

    }

    function mainCal() {
        var subtotal = $(".subtotal").val(),
//                litemdisc = $(".litemdisc").val(),
                cdiscperc = $(".cdiscperc").val(),
                cdiscamt = ((subtotal * cdiscperc) / 100).toFixed(2),
//                cdiscamt = (((subtotal - litemdisc) * cdiscperc) / 100).toFixed(2),
                coukg = $('.coukg').val(),
                courate = $(".courate").val(),
                lesother = $(".lesother").val(),
                couamt = (parseFloat(coukg) * parseFloat(courate)).toFixed(2),
//                netamt = (parseFloat(subtotal) - parseFloat(litemdisc) - parseFloat(cdiscamt) - parseFloat(lesother) + parseFloat(couamt)).toFixed(0),
                netamt = (parseFloat(subtotal) - parseFloat(cdiscamt) - parseFloat(lesother) + parseFloat(couamt)).toFixed(0),
                ladvance = $(".ladvance").val(),
                balance = (parseFloat(netamt) - parseFloat(ladvance)).toFixed(0),
                dcperc = $(".dcperc").val(),
                dcbperc = $(".dcbperc").val(),
                dcamt = Math.round((netamt * dcbperc / 100) * dcperc / 100);

        $(".cdiscamt").val(cdiscamt);
        $(".couamt").val(couamt);
        $(".netamt").val(netamt);
        $(".balance").val(balance);
        $(".dcamt").val(dcamt);

    }


    function checkMspTotal() {
        var subtotal = $(".subtotal").val(),
                cdiscamt = $(".cdiscamt").val(),
//                cdiscamt = (((subtotal - litemdisc) * cdiscperc) / 100).toFixed(2),
                lesother = $(".lesother").val(),
                msptotal = $(".msptotal").val(),
                msptotal = $(".msptotal").val(),
                otpdssucs = $(".otpdssucs").val(),
                newtotal = subtotal - cdiscamt - lesother;
        if (otpdssucs == "1") {
            $("#ssubmit").show();

        } else {
            if (msptotal > newtotal) {
                $("#overlay_form").show();
                $("#ssubmit").hide();
                $(".normotp").hide();
                $(".lesdsotp").show();
                $("#close_form1").show();
                $("#close_form").hide();

            } else {
                $("#overlay_form").hide();
                $("#ssubmit").show();

            }
        }


    }
///////////////////////////////////////////////////CALCULATION - END  //////////////////////////////////////////////////


    $("#close_form").click(function () {
        $("#overlay_form").hide();
        $(".rate").removeAttr("readonly", true);
        $(".mrp").focus();
        $(".rate").val("0");
        $("#ssubmit").show();


    });
    $("#close_form1").click(function () {
        $("#overlay_form").hide();
//        $(".les").removeAttr("readonly", true);
        $(".lesother").focus();
        $("#ssubmit").show();


    });
    $('#addnew').click(function () {
        AddRows();
    });
    function remove() {
        $(this).closest("tr").remove();
    }

    function AddRows() {
        var ctr = $('#items').val();
        var prodtype = $('.prodtype').val();
        var hide_check = "";
        if ($("#del_all").prop("checked")) {
            hide_check = 0;
        } else {
            hide_check = 1;
        }
        $(".otpsend").val("");
        $(".otprecv").val("");
        $(".otpsucs").val("");
        $(".otprowsucs").val("");
        var detail = ".fetchpart_" + ctr;
        $.post('sale_add.php', {ctr: ctr, hide: hide_check, prodtype: prodtype}, function (data) {
            $(data).appendTo('.tbody');
            ctr++;
            $('#items').val(ctr);
            $(detail).select2();
            if (prodtype == "") {
                $(".barcode").prop("disabled", true);
                $(".item").prop("disabled", true);
            }
        });
//        $(".barcode").focus();
    }

});